"""
Got from http://sourceforge.net/snippet/detail.php?type=snippet&id=100444
this is probably obsolete with the 'email' module in Python 2.2
"""

__version__ = "$Revision: 1.1.1.1 $"
# $Source: /home/vsbabu/repository/python/compmail/faktMimeMail.py,v $

import rfc822, string, sys, base64, os, os.path, mimetypes
import smtplib, MimeWriter, StringIO
from smtplib import *
from MyHTMLProcessor import MyHTMLProcessor

class faktMimeMail:

    def __init__(self, multipart_type="related",  host="localhost"):
        self.body       = "This is a multi-part message in MIME Format"
        self.text       = "This is a multi-part message in MIME Format"
        self.htmlbody   = ""
        self.to         = []
        self.frm        = ""
        self.rplto      = ""
        self.subject    = "No subject"
        self.parts      = []
        self.host = host
        self.multipart_type = multipart_type
        
        self.user       = ""
        self.password   = ""


    def settaServer(self,host_ ="localhost", user_="", password_="", replayTo_=""):
        self.host=host_
        self.user=user_
        self.password=password_
        self.frm=replayTo_
    
    def setHost(self, host="localhost"):
        self.host=host

    def setUser(self, user=""):
        self.user=user
    
    def setPassword(self, password=""):
        self.password=password
    
    
    def AddPart(self, type, data, name="untitled"):
        self.parts.append((type,data,name))

    def BodyHTML(self, html):
        self.htmlbody = html

    def AddFile(self, filename):
        name = os.path.basename(filename)
        t = mimetypes.guess_type(name)[0]
        self.AddPart(t, open(filename,"rb").read(),name)

    def Body(self, s):
        self.body = s

    def To(self, s):
        if type(s) == type([]):
            self.to = s
        else:
            self.to = [s]

    def From(self, s):
        self.frm = s

    def ReplyTo(self, s):
        self.rplto = s

    def Subject(self, s):
        self.subject = s

    def Get(self, index=-1):
        if index>=0:
            to = [self.to[index]]
        else:
            to = self.to
            
        if self.htmlbody or self.parts:

            self.out  = StringIO.StringIO("")
            self.mail = MimeWriter.MimeWriter(self.out)

            if not self.rplto: self.rplto = self.frm

            self.mail.addheader("To", string.join(to, ", "))
            if self.rplto:
                self.mail.addheader("Reply-to", self.rplto)          
            self.mail.addheader("From", self.frm)
            self.mail.addheader("Subject",  self.subject)
            self.mail.addheader("MIME-Version", "1.0")

            
            if self.body:
                self.text = self.body
                
            self.bodyout    = self.mail.startmultipartbody(self.multipart_type)
            self.bodyout.write(self.text+"\n\n")

            if self.htmlbody:
                part = self.mail.nextpart()
                part.addheader("Content-Transfer-Encoding","8bit")
                out  = part.startbody("text/html", [("charset","iso-8859-1"),("format","flowed")])
                out.write(self.htmlbody+"\n")

            for t, d, name in self.parts:
                part = self.mail.nextpart()
                part.addheader("Content-Transfer-Encoding","base64")
                if self.multipart_type in ('related', 'alternative'):
                    part.addheader("Content-ID", name)
                part.addheader("Content-Disposition","inline")
                if self.multipart_type in ('related', 'alternative'):
                    out  = part.startbody('%s; name="%s"' % (t, name))
                else:
                    out  = part.startbody(t, [("name",name)])#
                        #("Content-Transfer-Encoding","8bit")
                        #s])

                out.write(base64.encodestring(d))
                
            self.mail.lastpart()

            text = self.out.getvalue()
            self.out.close()

        else:
            rplto = ""
            if self.rplto: rplto = "Reply-To: %s\n" % self.rplto
            text = """To: %s
From: %s
Subject: %s
%sContent-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit

""" % (string.join(to, ", "), self.frm, self.subject, rplto) + self.body

        return text

    def Send(self, host="", single=1):
        if not host: host = self.host
        server = smtplib.SMTP(self.host)
        try:
            server.login(self.user,self.password)
        except SMTPException,instance:
            #print "ERRORE:", instance
            pass
        if single:
            for i in range(0,len(self.to)):
                server.sendmail(self.frm, self.to[i], self.Get(i))
        else:            
            server.sendmail(self.frm, self.to, self.Get())
        server.quit()
        return 1
        #else:
        #       return 0

    def sendEMail(self,to, subject="", directory=""):
        self.to=to
        self.subject=subject
        
        
        htmlFileToUse=""
        files=[]
        if  directory=="":
            return False
        
        while directory[len(directory)-1]=='\\' or directory[len(directory)-1]=='/':
            directory=directory[0:len(directory)-1]
        
        
        try:
            filesEdir=os.listdir(directory)
        except:
            print "Error:"+directory
            return False
        
        
        for entry in filesEdir:
            #print entry+":"
            statoFile=os.stat(directory+"/"+entry)        
            if statoFile[3]==1:
                # IS A FILE
                if len(entry)>4:
                    if (entry[-4:]==".htm" or entry[-4:]=="html") and htmlFileToUse=="":
                        htmlFileToUse=entry            
                        
                files.append(entry)
            else:
                # IS A DIRECTORY
                pass
                
        if htmlFileToUse=="":
            # I have not found an html or htm file !!!
	    print "NO HTML FILE FOUND in:"+str(files)
            return False
        
        # Now in files I have a list of files to add            
        # BUT I DON't USE IT NOW
        self.Body("there is an html")
        #mail.AddPart("application/pdf", open(r"c:\tmp\test.pdf").read())
        
        html_src = open(directory+"/"+htmlFileToUse, "r").read()
        parser = MyHTMLProcessor()
        parser.feed(html_src)
        parser.close()
        
        self.BodyHTML(parser.output())
        for img in parser.local_images():
            self.AddFile(directory+"/"+img)
        
        self.Send()


def sendmail(host="localhost", sender="Python Mail Module <python.mail.module@localhost>", to="", body="", subject=""):
    """
    Einfache Routine um E-Mails zu verschicken
    """
    try:
        server = smtplib.SMTP(host)
        try:
            server.login(self.user,self.password)
        except SMTPException,instance:
            #print "ERRORE:", instance
            pass
        if subject:
            body = "Subject: " + subject + "\n\n" + body
        server.sendmail(sender, [to], body)
        server.quit()
    except:
        print "Error while sending message"

    def errormail(to="error@localhost", subject="Python Error Message"):
        try:
            """
            Versendet eine E-Mail, die den letzten Traceback und
            die Umgebungsvariablen enthaelt
            """
            type=None
            value=None
            tb=None
            limit=None
    
            if type is None:
                type, value, tb = sys.exc_info()
            import traceback
    
            body = "Traceback (innermost last):\n"
            list = traceback.format_tb(tb, limit) + \
                   traceback.format_exception_only(type, value)
            body = body + "%s %s" % (
                string.join(list[:-1], ""),
                list[-1],
                )
    
            import os
            e = os.environ
            se = e.keys()
            se.sort()
    
            body = body + "\n\nENVIRONMENT VARIABLES\n\n"

            for k in se:
                body = body + "%26s  %s\n" % (k, str(e[k]   ))

            sendmail(to=to, body=body, subject=subject)

            del tb
        except:
            pass